import generator

instructions = generator.readYaml("music.yaml")


def createMusic(instructions, padding=0, actionbar=False):
    l, t = 0, 0
    dictFunction = f"## Search music\n"
    dictFunction += f"stopsound @s music\n"
    dictFunction += f"scoreboard players reset @s music.timer\n"
    dictFunction += f"tag @s add music.temp\n"

    for loop in instructions:
        print(loop)
        dictFunction += f"execute if score @s[tag=music.temp] music.loop matches {l} run function music:play/{loop}\n"
        loopFunction = f"## Search music for loop: {loop}\n"
        startT = t
        length = len(instructions[loop])

        def loopStart(start,length,pos):

            if start+length == pos+1:
                return start
            return pos+1
            pass

        for track in instructions[loop]:
            print('\t' + track)
            playFile = f"## Music: {track}\n"
            playFile = f"stopsound @s music\n"
            playFile += f"playsound {track} music @s ~ ~ ~ 1.0 1.0 1.0\n"
            playFile += f"scoreboard players set @s music.track {loopStart(startT,length,t)}\n"
            playFile += f"scoreboard players set @s music.loop {l}\n"
            playFile += f"scoreboard players set @s music.timer {instructions[loop][track]['length'] + padding}\n"
            playFile += f"tag @s remove music.temp\n"

            if(actionbar):
                playFile += f"""title @s actionbar [{{"translate":"now_playing","color":"#00FF6E"}},{{"translate":"music.0","color":"#00AAFF","bold":true}},{{"translate":"by","color":"#00FF6E"}},{{"translate":"music.0.author","color":"#4F7EFF"}}]"""

            loopFunction += f"execute if score @s[tag=music.temp] music.track matches {t} run function music:play/{loop}/{track}\n"
            generator.recursiveCreateFolder(f"./{loop}")
            generator.writeFunction(f"./{loop}/{track}",playFile)
            t += 1
            pass
        generator.writeFunction(f"./{loop}",loopFunction)
        l += 1
        pass
    generator.writeFunction(f"./dict",dictFunction)

createMusic(instructions,30)
